Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.impl.nio.reactor
Class DefaultConnectingIOReactor

    java.lang.Object
      org.apache.http.impl.nio.reactor.AbstractMultiworkerIOReactor
          org.apache.http.impl.nio.reactor.DefaultConnectingIOReactor

All Implemented Interfaces:
  ConnectingIOReactor, IOReactor

    public class DefaultConnectingIOReactor

extends AbstractMultiworkerIOReactor
implements ConnectingIOReactor

Default implementation of `ConnectingIOReactor`. This class extends `AbstractMultiworkerIOReactor` with capability to connect to remote hosts.

Since:
  4.0

Field Summary

Fields inherited from class org.apache.http.impl.nio.reactor.AbstractMultiworkerIOReactor
`auditLog, config, exceptionHandler, interestOpsQueueing, params, selector, selectTimeout, status`

Constructor Summary
`DefaultConnectingIOReactor()` Creates an instance of DefaultConnectingIOReactor with default configuration.
`DefaultConnectingIOReactor(int workerCount, HttpParams params)` Deprecated. (4.2) use `DefaultConnectingIOReactor(IOReactorConfig)`
`DefaultConnectingIOReactor(int workerCount, ThreadFactory threadFactory, HttpParams params)` Deprecated. (4.2) use `DefaultConnectingIOReactor(IOReactorConfig, ThreadFactory)`
`DefaultConnectingIOReactor(IOReactorConfig config)` Creates an instance of DefaultConnectingIOReactor with the given configuration.
`DefaultConnectingIOReactor(IOReactorConfig config, ThreadFactory threadFactory)` Creates an instance of DefaultConnectingIOReactor with the given configuration.

Method Summary
`protected void` | `cancelRequests()` Triggered to cancel pending session requests.
`SessionRequest` | `connect(SocketAddress remoteAddress, SocketAddress localAddress, Object attachment, SessionRequestCallback callback)` Requests a connection to a remote host.
`protected void` | `processEvents(int readyCount)` Triggered to process I/O events registered by the main `Selector`.

Methods inherited from class org.apache.http.impl.nio.reactor.AbstractMultiworkerIOReactor
`addChannel, addExceptionEvent, addExceptionEvent, awaitShutdown, doShutdown, execute, getAuditLog, getStatus, prepareSocket, registerChannel, setExceptionHandler, shutdown, shutdown`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.http.nio.reactor.IOReactor
`execute, getStatus, shutdown, shutdown`

Constructor Detail

### DefaultConnectingIOReactor

    public DefaultConnectingIOReactor(IOReactorConfig config,
                                      ThreadFactory threadFactory)
                               throws IOReactorException

  Creates an instance of DefaultConnectingIOReactor with the given configuration.

  Parameters:
    `config` - I/O reactor configuration.
    `threadFactory` - the factory to create threads. Can be `null`.
  Throws:
    `IOReactorException` - in case if a non-recoverable I/O error.
  Since:
    4.2

### DefaultConnectingIOReactor

    public DefaultConnectingIOReactor(IOReactorConfig config)
                               throws IOReactorException

  Creates an instance of DefaultConnectingIOReactor with the given configuration.

  Parameters:
    `config` - I/O reactor configuration. Can be `null`.
  Throws:
    `IOReactorException` - in case if a non-recoverable I/O error.
  Since:
    4.2

### DefaultConnectingIOReactor

    public DefaultConnectingIOReactor()
                               throws IOReactorException

  Creates an instance of DefaultConnectingIOReactor with default configuration.

  Throws:
    `IOReactorException` - in case if a non-recoverable I/O error.
  Since:
    4.2

### DefaultConnectingIOReactor

    @Deprecated
    public DefaultConnectingIOReactor(int workerCount,
                                                 ThreadFactory threadFactory,
                                                 HttpParams params)
                               throws IOReactorException

  Deprecated. (4.2) use `DefaultConnectingIOReactor(IOReactorConfig, ThreadFactory)`

  Throws:
    `IOReactorException`

### DefaultConnectingIOReactor

    @Deprecated
    public DefaultConnectingIOReactor(int workerCount,
                                                 HttpParams params)
                               throws IOReactorException

  Deprecated. (4.2) use `DefaultConnectingIOReactor(IOReactorConfig)`

  Throws:
    `IOReactorException`

Method Detail

### cancelRequests

    protected void cancelRequests()
                           throws IOReactorException

  Description copied from class: `AbstractMultiworkerIOReactor`
  Triggered to cancel pending session requests.

  Super-classes can implement this method to react to the event.

  Specified by:
    `cancelRequests` in class `AbstractMultiworkerIOReactor`
  Throws:
    `IOReactorException` - in case if a non-recoverable I/O error.

### processEvents

    protected void processEvents(int readyCount)
                          throws IOReactorException

  Description copied from class: `AbstractMultiworkerIOReactor`
  Triggered to process I/O events registered by the main `Selector`.

  Super-classes can implement this method to react to the event.

  Specified by:
    `processEvents` in class `AbstractMultiworkerIOReactor`
  Parameters:
    `readyCount` - event count.
  Throws:
    `IOReactorException` - in case if a non-recoverable I/O error.

### connect

    public SessionRequest connect(SocketAddress remoteAddress,
                                  SocketAddress localAddress,
                                  Object attachment,
                                  SessionRequestCallback callback)

  Description copied from interface: `ConnectingIOReactor`
  Requests a connection to a remote host.

  Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `SessionRequest` interface.

  There are several parameters one can use to exert a greater control over the process of session initialization:

  A non-null local socket address parameter can be used to bind the socket to a specific local address.

  An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

  It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `SessionRequestCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

  Specified by:
    `connect` in interface `ConnectingIOReactor`
  Parameters:
    `remoteAddress` - the socket address of the remote host.
    `localAddress` - the local socket address. Can be `null`, in which can the default local address and a random port will be used.
    `attachment` - the attachment object. Can be `null`.
    `callback` - interface. Can be `null`.
  Returns:
    session request object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.